#include <windows.h>
#include <tchar.h>
#include "CBm32.h"

#pragma comment(lib, "CBm32.lib")

#define MYWNDCLASS	TEXT("CLASS_CBm32Test")
#define MYWNDTITLE	TEXT("CBm32Test")

// fobOi[Nojp------------------
#define _CRTDBG_MAP_ALLOC
#include <crtdbg.h>
#ifdef _DEBUG
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif
//-------------------------------------------------

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

int WINAPI _tWinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPTSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static CBm32 bm1,bm2,bm3;
	static CFont32 font;
	
	switch (uMsg)
	{
	case WM_CREATE:
		font.Set(TEXT("lr o"), FW_MEDIUM, SHIFTJIS_CHARSET, DEFAULT_PITCH | FF_DONTCARE, PROOF_QUALITY);
		bm1.Create(300, 100);
		bm2.Create(TEXT("back.bmp"));
		bm3.Create(TEXT("star.bmp"));
		return 0;
	case WM_PAINT:
		{
			HDC 		hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			int wdh = bm2.GetWidth();
			int hgt = bm2.GetHeight();
			bm1.DrawColor(128, 255, 255, 255);
			bm1.DrawFont(TEXT("͂["), 80, 0, 0, 255, 255, 255);
			bm2.Hue(128, 100, 100, 200, 100);
			bm1.Draw32(bm2, 50, 50, 0, 0, wdh, hgt, 255);
			bm3.Draw32(bm2, 100, 150, 0, 0, 200, 200, 128);
			if(bm2.GetBPP() == 32){
				BYTE *pData = bm2.GetBits();
				int x,y;
				for(y=0; y<hgt/10; y++){
					for(x=0; x<wdh; x++){
						*pData = (BYTE) 0x00;	// 
						pData ++;
						*pData = (BYTE) 0xff;	// 
						pData ++;
						*pData = (BYTE) 0x00;	// 
						pData ++;
						*pData = (BYTE) 0x00;	// x
						pData ++;
					}
				}
			}
			bm2.DrawDC(hDC, 0, 0, 0, 0, wdh, hgt);
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
